/*******************************************************************************
*   $FILE:  BitBangSPI_Master.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*============================ ݸٰ =======================================*/
#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_SPI_BB)
#include <avr/io.h>
#include "BitBangSPI_Master.h"
#include "QDebugTransport.h"

/*============================  ==========================================*/
#define JOIN1( A, B, C ) A ## B ## C
#define CONCAT( A, B, C ) JOIN1( A, B, C )

/*============================================================================
O: BitBangSPI_Master_Init
------------------------------------------------------------------------------
ړI: BitBangSPI̪
: Ȃ
o: Ȃ
: QDebug.cQDebug_InitĂ΂܂B
============================================================================*/
void BitBangSPI_Master_Init (void)
{
	CONCAT( PORT, SPI_BB_SS, _DIRSET) =  ((1<<SS_BB));
	CONCAT( PORT, SPI_BB_MOSI, _DIRSET) =  (( 1 << MOSI_BB ));
	CONCAT( PORT, SPI_BB_SCK, _DIRSET) =  (( 1 << SCK_BB ));

	CONCAT( PORT, SPI_BB_MISO, _DIRCLR) =  ( 1 << MISO_BB );

	CONCAT( PORT, SPI_BB_SS, _OUTCLR) =  ((1<<SS_BB));
	CONCAT( PORT, SPI_BB_MOSI, _OUTCLR) =  (( 1 << MOSI_BB ));
	CONCAT( PORT, SPI_BB_SCK, _OUTCLR) =  (( 1 << SCK_BB ));
	CONCAT( PORT, SPI_BB_MISO, _OUTSET) =  ( 1 << MISO_BB );
}

/*============================================================================
O: BitBangSPI_Send_Byte
------------------------------------------------------------------------------
ړI: BitBangSPI̪gp1޲Ă𑗎M
: ]uׂ֑ް
o: ]uǂް
: ̧ٓBitBangSPI_Send_MessageĂ΂܂B
============================================================================*/
uint8_t BitBangSPI_Send_Byte (uint8_t c)
{
	unsigned bit;

	for (bit = 0; bit < 8; bit++) {
		/* Oۯ̌s[MOSI */
		if (c & 0x80)
			CONCAT( PORT, SPI_BB_MOSI, _OUTSET) =  ( 1 << MOSI_BB );
		else
			CONCAT( PORT, SPI_BB_MOSI, _OUTCLR) =  ( 1 << MOSI_BB );

		c <<= 1;
		DELAYUS(1);		/* s/㏸[̑O̔ۯ */
		CONCAT( PORT, SPI_BB_SCK, _OUTSET) = (1 << SCK_BB );
		DELAYUS(1);		/* s/~[̑O̔ۯ */

		/* s[MISOǂݍ */
		c |= ((CONCAT( PORT, SPI_BB_MISO, _IN) >> MISO_BB) & 0x01);
		CONCAT( PORT, SPI_BB_SCK, _OUTCLR) = (1 << SCK_BB );
	}
	CONCAT( PORT, SPI_BB_MOSI, _OUTCLR) =  ( 1 << MOSI_BB );
	DELAYUS(50);
	return c;
}

/*============================================================================
O: BitBangSPI_Send_Message
------------------------------------------------------------------------------
ړI: BitBangSPI̪gp1ڰт𑗎M
: Ȃ
o: Ȃ
: QDebugTransport.cSend_MessageĂ΂܂B
============================================================================*/
void BitBangSPI_Send_Message (void)
{
	unsigned int i;
	uint8_t FrameInProgress;

	// үޑo
	for (i=0; i <= TX_index; i++)
	{
		FrameInProgress = RxHandler(BitBangSPI_Send_Byte(TX_Buffer[i]));
	}

	// ޲Ă̎MKv?
	while (FrameInProgress)
		FrameInProgress = RxHandler(BitBangSPI_Send_Byte(0));
}
#endif /* _DEBUG_INTERFACE_ */
