/*******************************************************************************
*   $FILE:  eeprom_access.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/
#include "touch.h"

#ifdef _DEBUG_INTERFACE_

/*----------------------------------------------------------------------------
ݸٰ ̧
----------------------------------------------------------------------------*/
#include "eeprom_access.h"

/*----------------------------------------------------------------------------
^
----------------------------------------------------------------------------*/
static void eeprom_write (uint16_t ui_address, uint8_t ui_data);
static uint8_t eeprom_read (uint16_t ui_address);

/*----------------------------------------------------------------------------
ϸ
----------------------------------------------------------------------------*/
#if defined(_ATXMEGA_DEVICE_)
  #define NVM_EXEC() asm( "PUSH R30"     "\n\t"	\
						  "PUSH R31"     "\n\t"	\
						  "PUSH R16"     "\n\t"	\
						  "PUSH R18"     "\n\t"	\
						  "LDI R30,0xCB" "\n\t"	\
						  "LDI R31,0x01" "\n\t"	\
						  "LDI r16,0xD8" "\n\t"	\
						  "LDI r18,0x01" "\n\t"	\
						  "OUT 0x34,r16" "\n\t"	\
						  "ST Z,R18"     "\n\t"	\
						  "POP R18"      "\n\t"	\
						  "POP R16"      "\n\t"	\
						  "POP R31"      "\n\t"	\
						  "POP R30"      "\n\t"	\
                          )
#else
  #define EEPROM_WRITE() asm( "PUSH R24"     "\n\t"  \
							  "LDI R24,0x04" "\n\t"  \
							  "OUT 0x1F,R24" "\n\t"  \
							  "LDI R24,0x02" "\n\t"  \
							  "OUT 0x1F,R24" "\n\t"  \
							  "POP R24"      "\n\t"  \
							)
#endif /* defined(_ATXMEGA_DEVICE_) */

/*----------------------------------------------------------------------------
Oϐ
----------------------------------------------------------------------------*/
extern uint8_t num_sensors;
extern sensor_t sensors[];

/*==============================================================================
O: read_info_from_eeprom
--------------------------------------------------------------------------------
ړI: EEPROM򕔓ǂݍ
:
o:
: ߏ݂̌ײؔŔԍԂ܂B
==============================================================================*/
uint16_t read_info_from_eeprom (void)
{
	uint16_t rtnval;

	/* EEEPROMɊi[ꂽŏ2޲ĂײؔŔԍłB */
	rtnval = (uint16_t)(eeprom_read(EEPROM_START_ADDRESS));
	rtnval |= (uint16_t)(eeprom_read(EEPROM_START_ADDRESS + 1u)) << 8u;
	return rtnval;
}

/*==============================================================================
O: write_info_to_eeprom
--------------------------------------------------------------------------------
ړI: ײ؂̏ۑEEPROMɏ܂B
:
o:
: ݂ײؔŔԍEEPROMɏ܂B
==============================================================================*/
void write_info_to_eeprom (uint16_t lib_version)
{
	eeprom_write((EEPROM_START_ADDRESS), (uint8_t)(lib_version));
	eeprom_write((EEPROM_START_ADDRESS + 1u), (uint8_t)(lib_version >> 8u));
}

/*==============================================================================
O: write_global_settings_to_eeprom
--------------------------------------------------------------------------------
ړI: SҰݒEEPROM֕ۑ܂B
:
o:
:
==============================================================================*/
void write_global_settings_to_eeprom (void)
{
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 0u),
				  qt_config_data.qt_recal_threshold);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 1u),
				  qt_config_data.qt_di);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 2u),
				  qt_config_data.qt_drift_hold_time);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 3u),
				  qt_config_data.qt_max_on_duration);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 4u),
				  qt_config_data.qt_neg_drift_rate);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 5u),
				  qt_config_data.qt_pos_drift_rate);
	eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 6u),
				  qt_config_data.qt_pos_recal_delay);
}

/*==============================================================================
O: write_sensor_settings_to_eeprom
--------------------------------------------------------------------------------
ړI: mҰݒEEPROM֕ۑ
:
o:
:
==============================================================================*/
void write_sensor_settings_to_eeprom (void)
{
	uint8_t i;

	for(i = 0u; i < num_sensors; i++)
	{
		eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 7u + (i * 2u)),
					  sensors[i].threshold);
		eeprom_write((EEPROM_LIB_CONFIG_START_ADDRESS + 8u + (i * 2u)),
					  sensors[i].type_aks_pos_hyst);
	}
}

#ifdef _QMATRIX_
/*==============================================================================
O: write_burst_lenghts_to_eeprom
--------------------------------------------------------------------------------
ړI: WݒEEPROM֕ۑ
:
o:
:
==============================================================================*/
void write_burst_lenghts_to_eeprom (void)
{
	uint16_t address = EEPROM_LIB_CONFIG_START_ADDRESS + 7u + (num_sensors * 2u);
	uint8_t i;

	for(i = 0u; i < QT_NUM_CHANNELS; i++)
	{
		eeprom_write((address + i), qt_burst_lengths[i]);
	}
}
#endif

/*==============================================================================
O: read_settings_from_eeprom
--------------------------------------------------------------------------------
ړI: EEPROMݒǂݍ
:
o:
: ް͏Ŏ`'eeprom_gv_block[]'Ɋi[܂B
==============================================================================*/
void read_settings_from_eeprom (void)
{
	uint8_t i;
	/* Sʌ`Ԑݒǂݍ */
	qt_config_data.qt_recal_threshold =(recal_threshold_t)
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 0u);
	qt_config_data.qt_di              =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 1u);
	qt_config_data.qt_drift_hold_time =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 2u);
	qt_config_data.qt_max_on_duration =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 3u);
	qt_config_data.qt_neg_drift_rate  =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 4u);
	qt_config_data.qt_pos_drift_rate  =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 5u);
	qt_config_data.qt_pos_recal_delay =
		eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 6u);
	/* mL`Ԑݒǂݍ */
	for(i = 0u; i < num_sensors; i++)
	{
		sensors[i].threshold =
			eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 7u + (i * 2u));
		sensors[i].type_aks_pos_hyst =
			eeprom_read(EEPROM_LIB_CONFIG_START_ADDRESS + 8u + (i * 2u));
	}
	/* Sقɑ΂Wǂݍ */
  #ifdef _QMATRIX_
	uint16_t address = EEPROM_LIB_CONFIG_START_ADDRESS + 7u + (num_sensors * 2u);
	for(i = 0u; i < QT_NUM_CHANNELS; i++)
	{
		qt_burst_lengths[i] = eeprom_read((address + i));
	}
  #endif
}

/* m8515pC */
#ifndef EEPE
  #define EEPE EEWE
#endif

/*==============================================================================
O: eeprom_write
--------------------------------------------------------------------------------
ړI: ްEEPROM֏
: ްۑȂ΂ȂȂڽAް
o:
:
==============================================================================*/
void eeprom_write (uint16_t ui_address, uint8_t ui_data)
{
#if !defined(_ATXMEGA_DEVICE_)
	/* tiny/megaEEPROMp */
	while(EECR & (1<<EEPE));		/* Ȍ݂̊҂ */
	/* ڽްڼ޽\ݒ */
  #if defined ( __ICCAVR__ )
	EEAR = ui_address;
  #elif defined( __GNUC__ ) /* defined ( __ICCAVR__ ) */
	EEARL = ui_address;
  #endif /* defined( __GNUC__ ) */
	EEDR = ui_data;
	EEPROM_WRITE();
#else
	/* XMEGAEEPROMp */
	do{} while(( NVM.STATUS & NVM_NVMBUSY_bm ) == NVM_NVMBUSY_bm );		/* ۗNVM҂ */
	if ((NVM.STATUS & NVM_EELOAD_bm) != 0) {
		NVM.CMD = NVM_CMD_ERASE_EEPROM_BUFFER_gc;	/* w - EEPROMɏՕ */
		NVM_EXEC();									/* w - s */
	}
	NVM.CMD = NVM_CMD_LOAD_EEPROM_BUFFER_gc;		/* w - EEPROMɏՕݒ */
	NVM.ADDR0 = ui_address & 0xFF;					/* ݱڽݒ */
	NVM.ADDR1 = (ui_address >> 8) & 0x1F;
	NVM.ADDR2 = 0x00;
	NVM.DATA0 = ui_data;							/* ްݒ */
	NVM.CMD = NVM_CMD_ERASE_WRITE_EEPROM_PAGE_gc;	/* ݎwߐݒ */
	NVM_EXEC();
	do{} while(( NVM.STATUS & NVM_NVMBUSY_bm ) == NVM_NVMBUSY_bm );		/* ۗNVM҂ */
#endif
}

/*==============================================================================
O: eeprom_read
--------------------------------------------------------------------------------
ړI: EEPROMްǂݍ
: ްǂ܂Ȃ΂ȂȂEEPROMڽ
o: 8ޯ ް
:
==============================================================================*/
uint8_t eeprom_read (uint16_t ui_address)
{
#if !defined(_ATXMEGA_DEVICE_)
	/* tiny/megaEEPROMp */
	while(EECR & (1<<EEPE));		/* Ȍ݂̊҂ */
	/* ڽ ڼ޽\ݒ */
  #if defined ( __ICCAVR__ )
	EEAR = ui_address;
  #elif defined( __GNUC__ ) /* defined ( __ICCAVR__ ) */
	EEARL = ui_address;
  #endif /* defined( __GNUC__ ) */
	EECR |= (1<<EERE);				/* EERE݂ɂEEPROMǂݍ݊Jn */
	return EEDR;					/* ް ڼ޽ްԂB */
#else
	/* XMEGAEEPROMp */
	do{} while(( NVM.STATUS & NVM_NVMBUSY_bm ) == NVM_NVMBUSY_bm );		/* ۗNVM҂ */
	NVM.ADDR0 = ui_address & 0xFF;			/* ǂݍݗpڽݒ */
	NVM.ADDR1 = (ui_address >> 8) & 0x1F;
	NVM.ADDR2 = 0x00;
	NVM.CMD = NVM_CMD_READ_EEPROM_gc;		/* w - EEPROMǂݍ */
	NVM_EXEC();								/* w - s */
	return NVM.DATA0;						/* ްp\ */
#endif
}
#endif
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-EOF-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
