/*******************************************************************************
*   $FILE: QDebugTransport.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

#include "touch.h"

#ifdef _DEBUG_INTERFACE_

/*----------------------------------------------------------------------------
ݸٰ ̧
----------------------------------------------------------------------------*/
#include "touch_api.h"
#include "QDebug.h"
#include "QDebugTransport.h"
#include "QDebugSettings.h"

#if defined(QDEBUG_SPI)
  #include "SPI_Master.h"
#elif defined(QDEBUG_TWI)
  #include "TWI_Master.h"
#elif defined(QDEBUG_SPI_BB)
  #include "BitBangSPI_Master.h"
#else
  #warning "No Debug Interface is selected in QDebugSettings.h"
#endif

/*----------------------------------------------------------------------------
Sϐ
----------------------------------------------------------------------------*/

#ifdef _TOUCH_ARM_
  #ifdef __ICCARM__				// IAR
	#pragma data_alignment=16	// IAR
	#define __attribute__(...)	// IAR
  #endif						// IAR
  __attribute__((aligned(16)))
#endif /* TOUCH_ARM */
uint8_t TX_Buffer[TX_BUFFER_SIZE];

uint8_t RX_Buffer[RX_BUFFER_SIZE];
uint16_t TX_index;
uint16_t RX_index;
uint8_t SequenceL=0;
uint8_t SequenceH=0;
#ifdef _OPT_SRAM_
  uint8_t packet_crc = 0;
#endif

/*============================================================================
O: Init_Buffers
------------------------------------------------------------------------------
ړI: MɏՕ
: Ȃ
o: Ȃ
: QDebug_InitĂ΂܂B
============================================================================*/
void Init_Buffers (void)
{
	int i;

	for (i = 0; i < sizeof(RX_Buffer); i++)
	{
#ifndef _OPT_SRAM_
		TX_Buffer[i] = 0;
#endif
		RX_Buffer[i] = 0;
	}
#ifdef _OPT_SRAM_
	TX_index = 0;
#else
	TX_Buffer[0] = MESSAGE_START;
	TX_index = 4;	// MSG_START,MSG_SIZEH,MSG_SIZELƗԍް̒ǉJn
#endif
	RX_index=0;
}
#ifdef _OPT_SRAM_
/*============================================================================
O: PutChar
------------------------------------------------------------------------------
ړI: 1޲ĂްQTouch Studio֑M
: ׂް
o: Ȃ
: ߹ĂCRCvZ
============================================================================*/
void PutChar (uint8_t data)
{
	packet_crc ^= data;
	TX_Buffer[0] = data;
#if defined(QDEBUG_SPI)
	SPI_Send_Message();
//#elif defined(QDEBUG_TWI)
//	TWI_Send_Byte(data);
#elif defined(QDEBUG_SPI_BB)
	BitBangSPI_Send_Message();
#endif
}

/*============================================================================
O: PutInt
------------------------------------------------------------------------------
ړI: 2޲ĂްQTouch Sudio֑M
: Ȃ
o: Ȃ
: Ȃ
============================================================================*/
void PutInt (uint16_t data)
{
	PutChar((uint8_t)(data >> 8));
	PutChar((uint8_t)data);
}
#else
/*============================================================================
O: PutChar
------------------------------------------------------------------------------
ړI: MɏՕ1޲Ău
: Ȃ
o: Ȃ
: TX_index㑝܂B
============================================================================*/
void PutChar (uint8_t data)
{
	TX_Buffer[TX_index++] = data;
}

/*============================================================================
O: PutInt
------------------------------------------------------------------------------
ړI: MɏՕ2޲Ău
: Ȃ
o: Ȃ
: ޯ ި݁BTX_index㑝܂B
============================================================================*/
void PutInt (uint16_t data)
{
	TX_Buffer[TX_index++] = data >> 8;
	TX_Buffer[TX_index++] = data;
}
#endif
/*============================================================================
O: GetChar
------------------------------------------------------------------------------
ړI: MɏՕ1޲Ď擾
: Ȃ
o: Ȃ
: RX_index㑝܂B
============================================================================*/
uint8_t GetChar (void)
{
	return RX_Buffer[RX_index++];
}
#ifndef _OPT_SRAM_
/*============================================================================
O: Send_Message
------------------------------------------------------------------------------
ړI: QDebugSettings.hőIꂽ̪gpTX_Buffer̓eUSBد
	  ɑo
: Ȃ
o: Ȃ
: QDebug.c̑M֐Ă΂܂B
============================================================================*/
void Send_Message (void)
{
	uint16_t i;
	uint8_t checksum = 0;

	SequenceL = (SequenceL+1)& 0x0F;			// +1Ɗۂ
	TX_Buffer[1] = (uint8_t)(TX_index >> 8);	// ̈i[
	TX_Buffer[2] = (uint8_t)(TX_index & 0xFF);
	TX_Buffer[3] = (SequenceH<<4)+SequenceL;	// ԍi[
	for (i=1; i < TX_index; i++)				// ьvZ
		checksum ^= TX_Buffer[i];
	TX_Buffer[TX_index] = checksum;

	// I̪gpްo
  #if defined(QDEBUG_SPI)
	SPI_Send_Message();
  #elif defined(QDEBUG_TWI)
	TWI_Send_Message();
  #elif defined(QDEBUG_SPI_BB)
	BitBangSPI_Send_Message();
  #endif

	// үޏ
	TX_index = 4;
}
#endif
/*============================================================================
O: Receive_Message
------------------------------------------------------------------------------
ړI: ̪ƂTWIIĂꍇɎ呕uǂݍݑMsāA
	  RX_BufferLڰт
: Ȃ
o: Lڰтp\ۂɈˑTRUE܂FALSEԂB
: QDebug.cQDebug_ProcessCommandsĂ΂܂B
============================================================================*/
uint8_t Receive_Message (void)
{
#if defined(QDEBUG_TWI)
	static uint8_t count=0;

	count++;
	if (count == 10)
	{
		count=0;
		TWI_Retrieve_Message();
	}
	else
	{
		return 0;
	}
#endif

	// ʕ[
	if (RX_Buffer[0] != 0x1B)
		return 0;

	// ȂALڰюM!
	RX_index = 4;	// GetChar()͖ID𓾂܂B
	return 1;
}

/*============================================================================
O: RxHandler
------------------------------------------------------------------------------
ړI: QDebugSettings.hőI̪̓޲ĂA޲Ă
	  RX_Bufferɒu܂B
: I̪ɂēǂ܂ꂽް
o: ްǂ܂Ȃ΂ȂȂꍇTRUEAڰт̏ꍇFALSE
	  Ԃ܂B
: SPITWI̎MɂĎgp܂B
============================================================================*/
uint8_t RxHandler (uint8_t c)
{
	static uint16_t length = 0;
	static uint16_t received = 0;
	static uint8_t state = STATE_IDLE;
	uint8_t nextstate;
	uint8_t checksum;
	uint16_t i;

	switch (state)
	{
		case STATE_IDLE:
			if (c == 0x1B)
			{
				nextstate = STATE_LENGTH1;
			}
			else
				nextstate = STATE_IDLE;
			break;

		case STATE_LENGTH1:
			RX_Buffer[1] = c;
			length = c << 8;
			nextstate = STATE_LENGTH2;
			break;

		case STATE_LENGTH2:
			RX_Buffer[2] = c;
			length |= c;
			if ((length < 4) || (length > 270))
			{	// sAj
				nextstate = STATE_IDLE;
			}
			else
			{
				received = 3;
				nextstate = STATE_DATA;
			}
			break;

		case STATE_DATA:
			RX_Buffer[received] = c;
			if (received == length)
			{	// CRC޲
				checksum = 0;
				for (i = 1; i <= length; i++)
					checksum ^= RX_Buffer[i];

				if (checksum == 0)
				{	// Lڰ
					RX_Buffer[0] = 0x1B;
				}
				nextstate = STATE_IDLE;
				break;
			}
			nextstate = STATE_DATA;
			received++;;
			break;

		default:
			nextstate = STATE_IDLE;
	}
	state = nextstate;
	return state;
}
#endif
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-EOF-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
