/******************************************************************************* 
*   $FILE: TWI_Master.c
*   Atmel Corporation: http://www.atmel.com \n
*   xEҰ: touch@atmel.com
******************************************************************************/

/*  
*  쌠 (c) 2010, Atmel Corporation S\ς݁B
*
*  ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
*  ΋܂B
*
*  1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	  Ȃ΂Ȃ܂B
*
*  2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
*  3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	  (ۏ)ɎgpłȂ܂B
*
*  ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
*  ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
*  mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
*  ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
*  fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
*  RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
*  Ȃł傤B
*/

/*============================ ݸٰ =======================================*/
#include "touch.h"

#if defined(_DEBUG_INTERFACE_) && defined(QDEBUG_TWI)
#include "TWI_Master.h"
#include "QDebugTransport.h"
#include "avr_compiler.h"

/*============================ Ǐϐ ======================================*/
TWI_Master_t twiMaster;			/*!< TW呕uPʕ */

/*============================  ==========================================*/
unsigned int gMsTimeout;
#define NOT_TIMEDOUT()			(gMsTimeout)
#define SET_TIMEOUT(timeout)	(gMsTimeout = timeout)


/*============================================================================
O: TWI_Master_Init
------------------------------------------------------------------------------
ړI: TWI̪
: Ȃ
o: Ȃ
: QDebug.cQDebug_InitĂ΂܂B
============================================================================*/
void TWI_Master_Init (void)
{
	/* ײނQT600-ATXMEGA128A1-QT16TWICgpďĂ܂B
	   ײނʂ̊ɎgpꍇAǂTWIgp邩𒲂ׂ
	   IꂽTWIւ߲Őݒ肳Ȃ΂Ȃ܂B
	*/

	/* ʊ荞݋ */
	PMIC.CTRL |= PMIC_LOLVLEN_bm;

	// TWI呕u
	twiMaster.interface = &TWIC;
	twiMaster.interface->MASTER.BAUD	=	TWI_BAUDSETTING;
	twiMaster.interface->MASTER.CTRLA	=	TWI_MASTER_INTLVL_LO_gc |
											TWI_MASTER_RIEN_bm |
											TWI_MASTER_WIEN_bm |
											TWI_MASTER_ENABLE_bm;
	twiMaster.interface->MASTER.STATUS	=	TWI_MASTER_BUSSTATE_IDLE_gc;
	twiMaster.status = TWIM_STATUS_READY;
}

/*============================================================================
O: TWI_Retrieve_Message
------------------------------------------------------------------------------
ړI: TWI̪gp1ڰѓǂݍ
: Ȃ
o: ]ȂTRUEԂ܂B
: QDebugTransport.cReceive_MessageĂ΂܂B
============================================================================*/
bool TWI_Retrieve_Message (void)
{
	SET_TIMEOUT(10);						// 10ms

	// ޽ȂAPʓ]Jn
	if (twiMaster.status == TWIM_STATUS_READY)
	{
		twiMaster.status = TWIM_STATUS_BUSY;
		twiMaster.result = TWIM_RESULT_UNKNOWN;

		twiMaster.address = SLAVE_ADDRESS<<1;
		twiMaster.bytesWritten = 0;
		twiMaster.bytesRead = 0;

		// Jn+ڽ+'R/W=1'o
		uint8_t readAddress = twiMaster.address | 0x01;
		twiMaster.interface->MASTER.ADDR = readAddress;
	}
	else
	{
		return false;
	}

	// Pʓ]܂͐Ԃ܂őҋ@
	while ((twiMaster.status != TWIM_STATUS_READY) && NOT_TIMEDOUT());

	twiMaster.status= TWIM_STATUS_READY;

	if (gMsTimeout)
		return true;
	else
		return false;
}

/*============================================================================
O: TWI_Send_Message
------------------------------------------------------------------------------
ړI: TWI̪gp1ڰёo
: Ȃ
o: ]ȂATRUEԂ܂B
: QDebugTransport.cSend_MessageĂ΂܂B
============================================================================*/
bool TWI_Send_Message (void)
{
	SET_TIMEOUT(10);						// 10ms

	// ޽ȂAPʓ]Jn
	if (twiMaster.status == TWIM_STATUS_READY)
	{
		twiMaster.status = TWIM_STATUS_BUSY;
		twiMaster.result = TWIM_RESULT_UNKNOWN;
		twiMaster.address = SLAVE_ADDRESS<<1;
		twiMaster.bytesToWrite = (TX_Buffer[1]<<8)+TX_Buffer[2];
		twiMaster.bytesWritten = 0;

		// ݖ߂ȂAJn+ڽ+'R/W=0'𑗏o
		if (twiMaster.bytesToWrite > 0)
		{
			uint8_t writeAddress = twiMaster.address & ~0x01;
			twiMaster.interface->MASTER.ADDR = writeAddress;
		}
	}
	else
	{
		return false;
	}

	// Pʓ]܂͐Ԃ܂őҋ@
	while ((twiMaster.status != TWIM_STATUS_READY) &&  NOT_TIMEDOUT());
	
	twiMaster.status= TWIM_STATUS_READY;

	if (gMsTimeout)
		return true;
	else
		return false;
}

/*============================================================================
O: TWI_MasterInterruptHandler
------------------------------------------------------------------------------
ړI: TWI荞ݔTWIް
: Ȃ
o: Ȃ
: TWI呕u荞ݏ
============================================================================*/
ISR(TWIC_TWIM_vect)
{
	TWI_MasterInterruptHandler();
}

void TWI_MasterInterruptHandler (void)
{
	uint8_t currentStatus = twiMaster.interface->MASTER.STATUS;

	// r܂޽ُ
	if ((currentStatus & TWI_MASTER_ARBLOST_bm) ||
	    (currentStatus & TWI_MASTER_BUSERR_bm))
	{
		TWI_MasterArbitrationLostBusErrorHandler();
	}

	// 呕u݊荞݂ŁA
	else if (currentStatus & TWI_MASTER_WIF_bm) {
		TWI_MasterWriteHandler();
	}

	// 呕uǂݍ݊荞݂ŁA
	else if (currentStatus & TWI_MASTER_RIF_bm) {
		TWI_MasterReadHandler();
	}

	// \ʏԂŁA
	else {
		TWI_MasterTransactionFinished(TWIM_RESULT_FAIL);
	}
}

/*============================================================================
O: TWI_MasterArbitrationLostBusErrorHandler
------------------------------------------------------------------------------
ړI: ޽ُ̏ꍇɎ銈
: Ȃ
o: Ȃ
:
============================================================================*/
void TWI_MasterArbitrationLostBusErrorHandler (void)
{
	uint8_t currentStatus = twiMaster.interface->MASTER.STATUS;

	if (currentStatus & TWI_MASTER_BUSERR_bm) {		// ޽ُŁA
		twiMaster.result = TWIM_RESULT_BUS_ERROR;
	}
	else {											// rŁA
		twiMaster.result = TWIM_RESULT_ARBITRATION_LOST;
	}
	// 荞ݗv׸މ
	twiMaster.interface->MASTER.STATUS = currentStatus | TWI_MASTER_ARBLOST_bm;
	twiMaster.status = TWIM_STATUS_READY;
}

/*============================================================================
O: TWI_MasterWriteHandler
------------------------------------------------------------------------------
ړI: TWI
: Ȃ
o: Ȃ
: TWI荞ݏٰ݂Ă΂܂B
============================================================================*/
void TWI_MasterWriteHandler (void)
{
	// ׂ߲̌x邽߂̌̏ꍇɎgpǏϐ
	uint16_t bytesToWrite = twiMaster.bytesToWrite;
//	uint16_t bytesToRead  = twiMaster.bytesToRead;

	// ]uɂے艞(NACK)Pʓ]ꍇ
	if (twiMaster.interface->MASTER.STATUS & TWI_MASTER_RXACK_bm) {
		twiMaster.interface->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
		twiMaster.result = TWIM_RESULT_NACK_RECEIVED;
		twiMaster.status = TWIM_STATUS_READY;
	}

	// ޲ĂꍇAް𑗏o
	else if (twiMaster.bytesWritten <= bytesToWrite)
	{
		uint8_t data = TX_Buffer[twiMaster.bytesWritten];
		twiMaster.interface->MASTER.DATA = data;
		++twiMaster.bytesWritten;
	}

	// Pʓ]IȂA~𑗏oČʂOKɐݒ
	else {
		twiMaster.interface->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
		TWI_MasterTransactionFinished(TWIM_RESULT_OK);
	}
}

/*============================================================================
O: TWI_MasterReadHandler
------------------------------------------------------------------------------
ړI: TWI
: Ȃ
o: Ȃ
: TWI荞ݏٰ݂Ă΂܂B
============================================================================*/
void TWI_MasterReadHandler (void)
{
	uint8_t FrameInProgress;

	uint8_t data = twiMaster.interface->MASTER.DATA;
	FrameInProgress = RxHandler(data);
	// ޲ĂǂޏꍇAACK𔭍s޲ēǂݍ݂Jn
	if (FrameInProgress)
	{
		twiMaster.interface->MASTER.CTRLC = TWI_MASTER_CMD_RECVTRANS_gc;
	}
	else	// Pʓ]IȂANACKƒ~𔭍s
	{
		twiMaster.interface->MASTER.CTRLC = TWI_MASTER_ACKACT_bm | TWI_MASTER_CMD_STOP_gc;
		TWI_MasterTransactionFinished(TWIM_RESULT_OK);
	}
}

/*============================================================================
O: TWI_MasterTransactionFinished
------------------------------------------------------------------------------
ړI: TWIԕϐXV
: Ȃ
o: Ȃ
: TWI荞ݏٰ݂Ă΂܂B
=============================================================================*/
void TWI_MasterTransactionFinished (uint8_t result)
{
	twiMaster.result = result;
	twiMaster.status = TWIM_STATUS_READY;
}

#endif
